// const.cpp
#include <iostream.h>
#include <iomanip.h>

void safe_func(const char *instr)
{
	// instr[1] = 'a'; *** ILLEGAL, can't assign to const
}

void unsafe_func(char *instr)
{
	instr[1] = 'a'; // *** LEGAL
	instr[2] = 'n';
	instr[3] = 'e';
}

void main()
{
	const long magic_number = 369369;	
	// magic_number = 5; *** ILLEGAL, can't assign to const	

	const char *cptr = "Hello World.";  // ptr to constant
	cout << "Constant string is " << cptr << endl;
	
	const long *lptr = &magic_number; // ptr to constant
	cout << "Constant long is " << *lptr << endl;
	// *lptr = 200;  *** ILLEGAL, can't assign to const
	
	char *const constp = "aoeui";  // constant pointer
	cout << "Const ptr points to " << constp << endl;
	// constp = cptr;  *** ILLEGAL, can't assign to const
	cptr = constp;
	cout << "Ptr to const is now " << cptr << endl;

	// const long pointer to const long
	const long *const lp = &magic_number; 
	cout << "Const ptr to const points to " << *lp << endl;
	
	char name[] = "John Doe";
	safe_func(name);
	cout << "After safe_func, name is " << name << endl;
	
	unsafe_func(name);
	cout << "After unsafe_func, name is " << name << endl;
}
