// budget.cpp
#include <iostream.h>

#include "moneyLib.h"
#include "DList.h"

#include "dbgnew.h"

class moneyNode : public dNode {
	protected:
		money data;
	public:
		moneyNode() { data = 0;}
		moneyNode(float indata) { data = indata; }
		~moneyNode() { }
		moneyNode *next() { return (moneyNode *) dNode::next(); }
		void print(ostream &stream) { stream << data; }
		money getdata() { return data; }
};	

/* For homogenous lists it is better if the list is aware of the 
   specific node it will store.  This reduces the number of 
   virtual functions we need.  As you will see in Chapter 12,
   Templates make this much simpler. */
class budgetList {
	protected:
		moneyNode *_head;
		moneyNode *_tail;
		int width;
	public:
		budgetList();
		~budgetList();
		// insert into list
		budgetList &operator << (moneyNode *op);
		moneyNode *head() { return _head; }
		moneyNode *tail() { return _tail; }
		friend ostream &operator << (ostream &stream, budgetList &other);
		String total();
		void prtTotal(ostream &stream);
};

budgetList::budgetList()
{
	_head = _tail = 0;
}

budgetList::~budgetList() { }

budgetList &budgetList::operator << (moneyNode *op)
{
	if (_tail)
	{
		_tail->link(*op);
		_tail = op;
	}
	else
	{
		// first node
		_head = op;
		_tail = op;
	}
	return *this;
}

String budgetList::total()
{
	moneyNode *traverse=0;
	money temp;
	int total=0;
	
	for (traverse = _head; traverse; traverse = traverse->next())
	{
		total += (double) traverse->getdata();
	}
	
	temp = total;
	return (String)temp;
}

ostream &operator << (ostream &stream, budgetList &other)
{
	moneyNode *traverse=0;
	int cnt=0, len=0, maxlen=0, diff=0;
	String TOT = other.total();
	
	maxlen = TOT.getlen();
	
	for (traverse = other._head; traverse; traverse = traverse->next())
	{
		len = (traverse->getdata()).Strlen();
		diff = maxlen - len;
		while (diff--)
			cout << ' ';
		traverse->print(stream);
		stream << endl;
	}
	return stream;
}

void budgetList::prtTotal(ostream &stream)
{
	int len=0;
	String TOT = total();
	len = TOT.getlen();
	while (len--)
		stream << '-';
	stream << endl;
	cout << TOT << endl;
}

#define __MW__

#ifdef __MW__
void *operator new(size_t, void *p) { return p; }
#endif

int main()
{
	budgetList budget;
	String total;

	budget << new moneyNode(30.33) << new moneyNode(40.44);
	budget << new moneyNode(-22.45) << new moneyNode(-349.48);
	budget << new moneyNode(213.44) << new moneyNode(1234.55);
	budget << new moneyNode(9009.345);
	cout << "budget: " << endl;
	cout << budget;
	budget.prtTotal(cout);
	return 0;
}
