// hashtst.cpp
#include <iostream.h>
#include <string.h>

//const int HASHSZ = 512;
//const int HASHMSK = 0x01ff;

const int HASHSZ = 1024;
const int HASHMSK = 0x03ff;

long hash(char *name)
{
	int i=0, len=strlen(name);
	static int cnt=0;
	
	// scatter, scramble & squeeze	
	long scatter=0;
	// scatter - get a unique number
	for (i=0; i < len; i++)
	{
		scatter += name[i] + i + HASHSZ;
	}
		
	// scramble - "scramble" the bits
	long shiftr = scatter >> 3;
	long shiftl = scatter << 3;
	long scramble = shiftr ^ shiftl;  // XOR
	
	// squeeze - force the number into our range
	long squeeze = scramble & HASHMSK;
		
	return squeeze;
}

int main()
{
	short hit[HASHSZ];
	char otst[60] = "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA";
	char tst[60] =  "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA";
	int len = strlen(tst);
	long bcnt=0;
	for (int i=0; i < HASHSZ; i++)
		hit[i] = 0;
	
	for (i=0; i < HASHSZ; i++)
	{
		hit[hash(tst)]++;
		strcpy(tst,otst);
		tst[i%len] = tst[i%(len-1)] + (i % 50);
		tst[(i%len)+1] = '\0';
		if (!(i%2))
			tst[0] = tst[0] + (32 + (i%20));
	}
	
	for (i=0; i < HASHSZ; i++)
		if (hit[i])
			bcnt++;
			
	cout << "Hash Table SIZE is " << HASHSZ << endl;
	cout << "Number of Buckets filled is " << bcnt << endl;
	cout << "Hash Table is " << (bcnt*100)/HASHSZ << "% full." << endl;
	return 0;
}

