// dispatch.cpp
#include <iostream.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

void dir(char *dirname)
{
	cout << "Perform directory of " << dirname << endl;
}

void type(char *filename)
{
	cout << "Type this file: "<< filename << endl;
}

void find(char *pattern)
{
	cout << "Find this pattern: " << pattern << endl;
}

void del(char *filename)
{
	cout << "Delete this file: " << filename << endl;
}

struct funcTbl {
	char keyword[40];
	void (*action)(char *);
} fTbl[] = { { "DIR", dir },
	  	     { "TYPE", type },
	  	     { "FIND", find },
	  	     { "DEL", del } };

const int NUMactions = 4;

void upcase(char *str)
{
	// destructively Uppercases the string!
	while (*str)
	{
		if (islower(*str))
			*str = toupper(*str);
		str++;
	}
}

void do_action(char *cmd, char *arg)
{
	for (int i=0; i < NUMactions; i++)
	{
		if (!strcmp(cmd,fTbl[i].keyword))
		{
			fTbl[i].action(arg);
			break;
		}
	}
			
	if (i==NUMactions)
		cout << "Unknown Command!" << endl;
}

void main()
{
	int done=0;
	char command[80];
	char cmdArg[80];
	
	while (!done)
	{
		cout << "c:\> ";
		// should parse the command line, but this will do for demo
		cin >> command >> cmdArg;
		upcase(command);
		if (strcmp(command,"EXIT"))
			do_action(command,cmdArg);
		else
			done = 1;
	}
}
