// initref.cpp
#include <iostream.h>
#include <iomanip.h>

class testref {
	private:
		int myint;
		int &myref;  // EXCEPTION - initialize in constructor initializer list
	public:
		testref() : myref(myint) { myint = 0; }  // initialize reference
		testref(int input): myref(myint)  // initialize reference         
		{
			myint = input;
		}

		int getint(void)
		{
			return myint;
		}
		
		int &putint(void)            // return a reference
		{
			int &tempref = myint;
			return tempref;
		}
		
		testref &operator = (testref &other)  // parameter as a reference
		{
			myint = other.myint;
			myref = other.myint;
			return *this;
		}
		
		testref operator + (testref &other)  // parameter as a reference
		{
			testref temp;
			
			temp.myint = myint + other.myint;
			return temp;
		}
		
		void display(void)
		{
			cout << myint << endl;
		}
};

void main()
{
	int big = 10000;
	int small = 2;
	int num;
	
	int& smallref = small;  // regular initialization
/*	int& bigref;     *** ILLEGAL *** MUST INITIALIZE IT! */

	cout << "smallref is " << smallref << endl;

	testref testobj=5;
	testref testobj2=10;
	testref testobj3;
	
	testobj3 = testobj2 + testobj;
	
	cout << "testobj3 is ";
	testobj3.display();
	
	testobj2.putint() = 20;
	cout << "testobj2 is ";
	testobj2.display();
}
