// offsetof.cpp
#include <iostream.h>
#include <iomanip.h>
#include <stddef.h>
#include <string.h>
#include <ctype.h>

struct magazines {
	char type_code;  // p-programming, b-business, ...etc.
	float price;     // cost of magazine
	char title[21];  // title of magazine
	int month;
	int year;
};

void main()
{
	// Unlike C, C++ performs an automatic typedef on the structure
	// name
	magazines drdobbs;
	magazines *sp = &drdobbs;
	char *dump_ptr= (char *) &drdobbs;
	int i=0,j=0, offsets[5];
	
	drdobbs.type_code = 'p';
	drdobbs.price = 3.49;
	strcpy(drdobbs.title, "Dr. Dobb's Journal");
	drdobbs.month = 6;
	drdobbs.year = 1994;

	offsets[0] = offsetof(magazines,type_code);
	offsets[1] = offsetof(magazines,price);
	offsets[2] = offsetof(magazines,title);
	offsets[3] = offsetof(magazines,month);
	offsets[4] = offsetof(magazines,year);
	
	// let's examine the offsets
	cout << "magazine structure: " << sizeof(magazines) 
	                               << " bytes" << endl;
	cout << "  type_code offset: " << offsets[0] << " Value: " 
	                               << sp->type_code << endl;
	cout << "  price offset    : " << offsets[1] << " Value: " 
	                               << sp->price << endl;
	cout << "  title offset    : " << offsets[2] << " Value: " 
	                               << sp->title << endl;
	cout << "  month offset    : " << offsets[3] << " Value: " 
	                               << sp->month << endl;
	cout << "  year offset     : " << offsets[4] << " Value: " 
	                               << sp->year  << endl;
	cout << endl;
	
	// let's dump the bytes in hex and ASCII
	cout << "Hex/Ascii dump: " << sizeof(magazines) << " bytes" << endl;
	for (i=0; i < sizeof(magazines); i++)
	{
		if (i==offsets[j])
		{
			if (i)
				cout << endl;
			cout << dec << offsets[j] << ":";
			j++;
		}
		
		if (isalnum(dump_ptr[i]) || 
			ispunct(dump_ptr[i]) ||
			isspace(dump_ptr[i]) )
			cout << dump_ptr[i];
		else
			cout << hex << (int)dump_ptr[i];
	}
	cout << endl;
}
