// tinydict.h
const int SENTENCE_MAX = 3;
const int ENTRY_MAX = 30;
const int MENU_LIMIT = 20;

class dictionary_entry {
	protected:
		String keyword;
		String sentence[SENTENCE_MAX];
	public:
		dictionary_entry();
		~dictionary_entry();
		String get_keyword();
		friend ostream &operator << (ostream &stream, dictionary_entry &inobj);
		friend istream &operator >> (istream &stream, dictionary_entry &inobj);
};

class dictionary {
	protected:
		dictionary_entry listing[ENTRY_MAX];
		int entry_count;
	public:
		dictionary();
		~dictionary();
		void add_entry();
		void delete_entry();
		void list_entries();
		void find_entry();
};

class menu {
	protected:
		String choices[MENU_LIMIT];
		int num_choices;
		int choice;
		int header;
		int trailer;
	public:
		menu();
		menu(int numstrings, int inheader, int intrailer, ...);
		friend ostream &operator << (ostream &stream, menu &inobj);
		int menu_choice();
};
