// classnew.cpp
#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <new.h>

class little {
	protected:
		int num;
	public:
		little() { num=0; }
		little(int innum) { num=innum; }
		void setnum(int innum) { num=innum;}
		void prtnum() { cout << num; }
		void *operator new(size_t bytes);
		void operator delete(void *type);
};


void exhausted()
{
	cout << "Exhausted the store." << endl;
	exit(0);
}

// a wrapper structure to store info on the status
// of the dynamic object.
struct LittleBag {
	little theobject;
	short free;
};

// storage globals
LittleBag *store=0;
int store_sz=0;
int store_idx=0;
int store_max=5;   // such a tiny start for demo purposes only

void *little::operator new(size_t bytes)
{
	little *lp=0;
	int i=0;
	
	if (!store_sz)
	{
		// create the store
		store = (LittleBag *) malloc(sizeof(LittleBag) * store_max);
		if (!store)
			exhausted();
		// initialize
		for (i=0; i < store_max; i++)
			store[i].free=0;
		store_sz = store_max;
		store_idx = 0;
	}
	
	if (store_idx < store_max)
	{
		// return an open entry.
		cout << "Node " << store_idx << " is open." << endl;
		return &(store[store_idx++].theobject);
	}
	else
	{
		cout << "No open entries." << endl;
		// check if one was deleted
		for (i=0; i < store_max; i++)
		{
			if (store[i].free)
			{
				cout << "Node " << i << " is free." << endl;
				store[i].free=0;
				return &(store[i].theobject);
			}
		}
		
		if (i == store_max)
		{
			// if none deleted,
			// expand store
			// or return 0  -- for now let's just exhaust the store
			exhausted();
		}
	}
	
	return 0;
}
		
void little::operator delete(void *type)
{
	int i=0;
	// mark as deleted
	// since our store is tiny we will do this with
	// brute force
	
	if (!type)
		return;  // on a NULL pointer, do nothing
		
	for (i=0; i < store_max; i++)
	{
		if (type == &(store[i].theobject))
		{
			cout << "Deleting Node " << i << endl;
			store[i].free = 1;
		}
	}
}

void main()
{
	little *lp1=0, *lp2=0, *lp3=0, *lp4=0, *lp5=0;
	little *lp6=0;
		
	lp1 = new little;
	lp2 = new little;
	lp3 = new little;
	lp4 = new little;
	lp5 = new little;
	
	delete lp2;
	delete lp1;
	
	lp1 = new little;
	lp2 = new little;
	
	lp1->setnum(10);
	cout << "number in object 1 is ";
	lp1->prtnum();
	cout << endl;

	// now exhaust the free store
	lp6 = new little;
}

