// wrongcpy.cpp
#include <iostream.h>
#include <iomanip.h>
#include <assert.h>
#include <stdlib.h>
#include <string.h>
#include <new.h>

class Charstr {
	protected:
		char _objname[32];
		char *_str;
	public:
		Charstr();
		Charstr(char *inname,char *instr);
		~Charstr();
		// Charstr(Charstr &obj) -- if no copy constructor the
		// compiler provides a default, member-wise copy.
		friend ostream &operator << (ostream &stream, Charstr &inobj);
};

void exhausted()
{
	cout << "Free store is exhausted!" << endl;
	exit(0);
}

Charstr::Charstr()
{
	_str = 0;
}

Charstr::Charstr(char *inname,char *instr)
{
	cout << "Two-Arg Charstr constructor for " << inname << endl;
	assert(instr);
	_str = new char[strlen(instr) + 1];  // Don't forget one for Nul!!!
	strcpy(_str,instr);
	assert(strlen(inname) < 32);
	strcpy(_objname,inname);
}

Charstr::~Charstr()
{
	cout << "Charstr destructor for " << _objname << endl;
	cout << "Freeing pointer " << (void *)_str << endl;
	delete _str;
}

ostream &operator << (ostream &stream, Charstr &inobj)
{
	stream << "obj: " << inobj._objname << endl;
	stream << "str: " << inobj._str << endl;
	return stream;
}

void func1(Charstr inobj)
{
	cout << inobj;
}

void main()
{
	Charstr c1("c1","Mike"), c2("c2","Jack");
	set_new_handler(exhausted);
	func1(c1);
	func1(c2);
	func1(c1);
}
